// Browse.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "Browse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowse dialog

CBrowse::CBrowse(CWnd* pParent /*=NULL*/)
	: CDialog(CBrowse::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBrowse)
	m_path = _T("");
	m_title = _T("");
	//}}AFX_DATA_INIT
}

void CBrowse::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowse)
	DDX_Text(pDX, IDC_PATH, m_path);
	DDX_Text(pDX, IDC_TITLE, m_title);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBrowse, CDialog)
	//{{AFX_MSG_MAP(CBrowse)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, OnSelchangedTree)
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_TREE, OnItemexpandingTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowse message handlers

BOOL CBrowse::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Init tree control
	CTreeCtrl* pCtrl = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	TVINSERTSTRUCT insert;
	insert.hParent = TVI_ROOT;
	insert.hInsertAfter = TVI_SORT;
	insert.item.mask = TVIF_CHILDREN | TVIF_TEXT;
	insert.item.cChildren = 1;
	WIN32_FIND_DATA FindFileData;
	HANDLE findFile = FindFirstFile(_T("\\*.*"), &FindFileData); 
	BOOL result = (findFile != INVALID_HANDLE_VALUE);
	while (result)  {
		if (FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) {
			if (_tcscmp(FindFileData.cFileName,_T("."))!=0 && _tcscmp(FindFileData.cFileName,_T(".."))!=0) {
				insert.item.pszText = FindFileData.cFileName;
				HTREEITEM node = pCtrl->InsertItem(&insert);
			}
		}
		else {
			HTREEITEM node = pCtrl->InsertItem(FindFileData.cFileName,TVI_ROOT,TVI_SORT);
		}
		result=FindNextFile(findFile, &FindFileData ); 
	}
	return TRUE;  // return TRUE unless you set the focus to a control
}

// Update the path edit control when the selection in the tree control changes

void CBrowse::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CTreeCtrl* pCtrl = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	HTREEITEM hItem = pCtrl->GetSelectedItem();
	m_path = _T("");
	while (hItem!=NULL) {
		m_path = CString(_T("\\")) + pCtrl->GetItemText(hItem) + m_path;
		hItem = pCtrl->GetParentItem(hItem);
	}
	UpdateData(FALSE);

	*pResult = 0;
}

void CBrowse::OnItemexpandingTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	*pResult = 0;		// return value

	TVITEM pParent = pNMTreeView->itemNew;
	if (pNMTreeView->action != TVE_EXPAND) 
		return;
	if (pParent.state == TVIS_EXPANDEDONCE)
		return;

	CTreeCtrl* pCtrl = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	HTREEITEM hItem = pParent.hItem;

	// Get the path to the point to be expanded
	CString path = _T("");
	while (hItem!=NULL) {
		path = CString(_T("\\")) + pCtrl->GetItemText(hItem) + path;
		hItem = pCtrl->GetParentItem(hItem);
	}

	// expand the node
	WIN32_FIND_DATA FindFileData;
	TVINSERTSTRUCT insert;
	insert.hParent = pParent.hItem;
	insert.hInsertAfter = TVI_SORT;
	insert.item.mask = TVIF_CHILDREN | TVIF_TEXT;
	insert.item.cChildren = 1;
	HANDLE findFile = FindFirstFile(path+_T("\\*.*"), &FindFileData); 
	BOOL result = (findFile != INVALID_HANDLE_VALUE);
	while (result)  {
		if (_tcscmp(FindFileData.cFileName,_T("."))!=0 && _tcscmp(FindFileData.cFileName,_T(".."))!=0) {
			if (FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) {
				insert.item.pszText = FindFileData.cFileName;
				HTREEITEM node = pCtrl->InsertItem(&insert);
			}
			else {
				HTREEITEM node = pCtrl->InsertItem(FindFileData.cFileName,pParent.hItem,TVI_SORT);
			}
		}
		result=FindNextFile(findFile, &FindFileData ); 
	}
}
