// DictOptions.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "DictOptions.h"
#include "browse.h"
#include "MJDict.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMJDictApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDictOptions dialog

CDictOptions::CDictOptions(CWnd* pParent /*=NULL*/)
	: CDialog(CDictOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDictOptions)
	m_alt = _T("");
	m_altindex = _T("");
	m_index = _T("");
	m_kanjidic = _T("");
	m_main = _T("");
	//}}AFX_DATA_INIT
}

void CDictOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDictOptions)
	DDX_Text(pDX, IDC_ALT, m_alt);
	DDX_Text(pDX, IDC_ALTINDEX, m_altindex);
	DDX_Text(pDX, IDC_INDEX, m_index);
	DDX_Text(pDX, IDC_KANJIDIC, m_kanjidic);
	DDX_Text(pDX, IDC_MAIN, m_main);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDictOptions, CDialog)
	//{{AFX_MSG_MAP(CDictOptions)
	ON_BN_CLICKED(IDC_BROWSE1, OnBrowse1)
	ON_BN_CLICKED(IDC_BROWSE2, OnBrowse2)
	ON_BN_CLICKED(IDC_BROWSE3, OnBrowse3)
	ON_BN_CLICKED(IDC_BROWSE4, OnBrowse4)
	ON_BN_CLICKED(IDC_BROWSE5, OnBrowse5)
	ON_BN_CLICKED(IDC_DEFAULT, OnSetDefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDictOptions message handlers

BOOL CDictOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    m_main = theApp.GetProfileString(SECTION, _T("EDict"), _T("\\Program Files\\edict.euc"));
    m_index = theApp.GetProfileString(SECTION, _T("EDictIndex"), _T("\\Program Files\\edict.jdx"));
    m_alt = theApp.GetProfileString(SECTION, _T("Alt"), _T("\\Program Files\\enamdict.euc"));
    m_altindex = theApp.GetProfileString(SECTION, _T("AltIndex"), _T("\\Program Files\\enamdict.jdx"));
    m_kanjidic = theApp.GetProfileString(SECTION, _T("Kanjidic"), _T("\\Program Files\\Kanjidic.euc"));

	UpdateData(FALSE);	
	return TRUE;  // return TRUE unless you set the focus to a control
}

// Close the dialog box, saving the new settings and 
// then reopen all the dictionaries just in case any have changed

void CDictOptions::OnOK() 
{
	UpdateData(TRUE);	// get the new information

	// Update the registry
	theApp.WriteProfileString(SECTION, _T("EDict"), m_main);
	theApp.WriteProfileString(SECTION, _T("EDictIndex"), m_index);
	theApp.WriteProfileString(SECTION, _T("Alt"), m_alt);
	theApp.WriteProfileString(SECTION, _T("AltIndex"), m_altindex);
	theApp.WriteProfileString(SECTION, _T("Kanjidic"), m_kanjidic);

	EndDialog(IDOK);
}

// Browse button clicked, display browse dialog box

void CDictOptions::OnBrowse1() 
{
	CBrowse browseDlg;

	UpdateData(TRUE);
	browseDlg.m_title = _T("EDict path");
	browseDlg.m_path = m_main;

	if (browseDlg.DoModal() == IDOK) {
		m_main = browseDlg.m_path;
		UpdateData(FALSE);
	}
}

void CDictOptions::OnBrowse2() 
{
	CBrowse browseDlg;

	UpdateData(TRUE);
	browseDlg.m_title = _T("EDict index path");
	browseDlg.m_path = m_index;

	if (browseDlg.DoModal() == IDOK) {
		m_index = browseDlg.m_path;
		UpdateData(FALSE);
	}
}

void CDictOptions::OnBrowse3() 
{
	CBrowse browseDlg;

	UpdateData(TRUE);
	browseDlg.m_title = _T("Alternate dictionary path");
	browseDlg.m_path = m_alt;

	if (browseDlg.DoModal() == IDOK) {
		m_alt = browseDlg.m_path;
		UpdateData(FALSE);
	}
}

void CDictOptions::OnBrowse4() 
{
	CBrowse browseDlg;

	UpdateData(TRUE);
	browseDlg.m_title = _T("Alternate index path");
	browseDlg.m_path = m_altindex;

	if (browseDlg.DoModal() == IDOK) {
		m_altindex = browseDlg.m_path;
		UpdateData(FALSE);
	}
}

void CDictOptions::OnBrowse5() 
{
	CBrowse browseDlg;

	UpdateData(TRUE);
	browseDlg.m_title = _T("Kanjidic path");
	browseDlg.m_path = m_kanjidic;

	if (browseDlg.DoModal() == IDOK) {
		m_kanjidic = browseDlg.m_path;
		UpdateData(FALSE);
	}
}

// Set the dictionary paths and file names to the defaults
// Need to click OK afterwards to save the registry entries

void CDictOptions::OnSetDefault() 
{
	// Set the default file names and paths
    m_main = _T("\\Program Files\\edict.euc");
    m_index = _T("\\Program Files\\edict.jdx");
    m_alt = _T("\\Program Files\\enamdict.euc");
    m_altindex = _T("\\Program Files\\enamdict.jdx");
    m_kanjidic = _T("\\Program Files\\Kanjidic.euc");
	UpdateData(FALSE);	
}
