//======================================================================
// JPenWnd.cpp - An IM window
//======================================================================

#include <windows.h>
#define COBJMACROS
#include <aygshell.h>                // Palm-size PC shell includes
#include <sip.h>                     // SIP includes
#include <keybd.h>

#include "Stroke.h"
#include "kanjipen.h"
#include "JPenWnd.h"                  // Includes for this window
#include "resource.h"

extern HINSTANCE hInst;               // DLL instance handle
extern TCHAR errormsg[50];
extern BYTE * FontData;

void DrawButton(HDC hdc, int x, int y, TCHAR pChar, BOOL fPressed);
void DisplayBitmap(HDC hdc, int x, int y, TCHAR chr);
void InitFont();

POINT m_line[2];
CStroke m_strokes[30];
int m_nStrokeNo;
bool bLBDown;
CKanjiPen KP;
long BestScore[BESTSIZE+1];
TCHAR BestChar[BESTSIZE+1];
UINT Timer;
int timeleft;
int KeyDown;

// Message dispatch table for SipWindowProc
const struct decodeUINT SipMessages[] = {
    WM_CREATE, DoCreateSip,
    WM_PAINT, DoPaintSip,
    MYMSG_METHCALL, DoSetSipInfo,
    WM_LBUTTONDOWN, DoLButtonDownSip,
    WM_MOUSEMOVE, DoMouseMoveSip,
    WM_LBUTTONUP, DoLButtonUpSip,
    WM_DESTROY, DoDestroySip,
	WM_TIMER, DoTimerSip,
};
//======================================================================
// JPenWndProc - Window procedure for SIP 
//
LRESULT CALLBACK JPenWndProc(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
    INT  i;
    // Call routine to handle control message.
    for (i = 0; i < dim(SipMessages); i++) {
        if (wMsg == SipMessages[i].Code)
            return (*SipMessages[i].Fxn)(hWnd, wMsg, wParam, lParam);
    }
    return DefWindowProc (hWnd, wMsg, wParam, lParam);
}
//
//----------------------------------------------------------------------
//
void Recognise(HWND hWnd) 
{
	// TRACE(_T("Recognise\r\n"));
	int i;	
	TCHAR * sdPtr = KP.StrokeData+1;

	// move to correct number of strokes
	while (*sdPtr != 'z' && *sdPtr < m_nStrokeNo+'A') {
		while (*++sdPtr!='\n') ;
		++sdPtr;
	}

	// evaluate and keep lowest n scores
	for (i=0; i<BESTSIZE+1; i++) {
		BestScore[i]= (long)0x7FFFFFFF - 100; // very bad score
		BestChar[i] = ' ';
	}

//	_tcscpy(errormsg,_T(""));

	while (*sdPtr == m_nStrokeNo+'A') {
		long iscore = KP.StrokeScorerEvalItem(sdPtr+2,m_strokes,m_nStrokeNo,BestScore[BESTSIZE]+50); // Evaluate
/*		TCHAR t1[50]; t1[0] = *(sdPtr+1); t1[1]=0;
		_tcscat(errormsg,t1);
		_ltow(iscore,t1,10); _tcscat(errormsg,t1);
		_tcscat(errormsg,_T(", "));
*/
		// insert in top n list, (mostly at n+1)
		for (i=BESTSIZE-1; i>=0; --i) {
			if (iscore<BestScore[i]) {
				BestScore[i+1] = BestScore[i];
				BestChar[i+1] = BestChar[i];
			}
			else 
				break;
		}
		BestScore[i+1] = iscore;
		BestChar[i+1] = *(sdPtr+1);

		// find next character
		while (*++sdPtr!='\n') ;
		++sdPtr;
	}
	InvalidateRect(hWnd, NULL, TRUE);
}

void SendChar(HWND hWnd, TCHAR ch, int flag)
{
	LPSIPWNDSTRUCT pWndData;
	pWndData = (LPSIPWNDSTRUCT)GetWindowLong (hWnd, GWL_USERDATA);
	TCHAR cs[4];
	int i = 0;
	if (flag==1 ) { // delete first
		cs[i++]=VK_BACK;
	}

	if (ch=='{')
		cs[i++]=VK_BACK;
	else if (ch=='}')
		cs[i++]=VK_RETURN;
	else if (ch==' ')
		cs[i++]=VK_SPACE;
	else 
		cs[i++]=ch;
	pWndData->pIMCallback->SendString(cs,i);
}


//----------------------------------------------------------------------
// DoCreateSip - Process WM_CREATE message for window.
//
LRESULT CALLBACK DoCreateSip (HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
    LPSIPWNDSTRUCT pWndData;

    // Allocate a data structure for the SIP keyboard window.
    pWndData = (SIPWNDSTRUCT*)LocalAlloc (LPTR, sizeof (SIPWNDSTRUCT));
    if (!pWndData) {
        DestroyWindow (hWnd);
        return 0;
    }
    memset (pWndData, 0, sizeof (SIPWNDSTRUCT));

	KeyDown = 0;
	timeleft = 0;
	Timer = SetTimer(hWnd,1,100,NULL);
	m_nStrokeNo = -1;

	// Clear best match list
	for (int i=0; i<BESTSIZE+1; i++) {
		BestChar[i] = ' ';
	}
	InitFont();

    GetWindowRect (GetParent (hWnd), &pWndData->rectDocked);
    SetWindowLong (hWnd, GWL_USERDATA, (INT)pWndData);
    return 0;
}
//----------------------------------------------------------------------
// DoSetSipInfo - Process set information user message for window.
//
LRESULT CALLBACK DoSetSipInfo(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
    LPSIPWNDSTRUCT pWndData;
    RECT rect;

    pWndData = (LPSIPWNDSTRUCT)GetWindowLong (hWnd, GWL_USERDATA);
    switch (wParam) {
    // Called when RegisterCallback method called
    case 0:
        pWndData->pIMCallback = (IIMCallback *)lParam;
        break;
    // Called when GetInfo method called
    case 1:
        pWndData->imi = *(IMINFO *)lParam;
        break;
    // Called when ReceiveSipInfo method called
    case 2:
        GetClientRect (GetParent(hWnd), &rect);
        MoveWindow (hWnd, 0, 0, rect.right - rect.left,
                    rect.bottom - rect.top, TRUE);
        break;
    }
    return 0;
}
//----------------------------------------------------------------------
// DoPaintSip - Process WM_PAINT message for window.
//
LRESULT CALLBACK DoPaintSip (HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
	HDC hdc = BeginPaint (hWnd, &ps);

	// draw drawing grid
	HPEN hPen = CreatePen(PS_SOLID, 1, RGB(256, 192, 192));
	HPEN hOldPen = (HPEN)SelectObject(hdc,hPen);
	Polyline(hdc,GridLines,13);
	SelectObject(hdc,hOldPen);
	Polyline(hdc,Grid,5);
	
	// draw pen strokes
	int stroke=0;
	while (stroke <= m_nStrokeNo) {	
		Polyline(hdc,m_strokes[stroke].m_point,m_strokes[stroke].iLen);
		stroke++;
	}

	// Display n best
// For some reason Japanese font does not work
	LOGFONT lFont;
	lFont.lfHeight = 32; 
	lFont.lfWidth = 0; 
	lFont.lfEscapement = 0; 
	lFont.lfOrientation = 0; 
	lFont.lfWeight = 0; // FW_NORMAL; 
	lFont.lfItalic = 0; 
	lFont.lfUnderline = 0; 
	lFont.lfStrikeOut = 0; 
	lFont.lfCharSet = SHIFTJIS_CHARSET; 
	lFont.lfOutPrecision = OUT_DEFAULT_PRECIS; 
	lFont.lfClipPrecision = CLIP_DEFAULT_PRECIS; 
	lFont.lfQuality = DEFAULT_QUALITY; 
	lFont.lfPitchAndFamily = DEFAULT_PITCH; 
	int rc = LoadString(hInst,IDS_FONTNAME2,lFont.lfFaceName,30);
	HFONT font = CreateFontIndirect(&lFont);
	HFONT def_font = (HFONT)SelectObject(hdc,&font);
    for (int j=0; j<KEYROW; ++j) {
		for (int i=0; i<KEYCOL; ++i) {
			DrawButton(hdc,i,j,BestChar[i+j*KEYCOL],(i+j*KEYCOL+1)==KeyDown);
		}
	}
	// Finished with the font, now delete the font object.
	SelectObject(hdc,def_font);
	DeleteObject(font); 

    EndPaint (hWnd, &ps);
    return 0;
}
//----------------------------------------------------------------------
// DoMouseSip - Process mouse button messages for window. 
//
LRESULT CALLBACK DoLButtonDownSip (HWND hWnd, UINT wMsg, WPARAM nFlags, LPARAM lParam)
{
	POINT point;
	point.x = LOWORD(lParam);
	point.y = HIWORD(lParam);

	SetCapture (hWnd);

	timeleft=0;
	if (point.x>=KEYX && point.x<=KEYX+KEYSIZE*KEYCOL && point.y>=KEYY && point.y<=KEYY+KEYSIZE*KEYROW ) {
		int x, y;
		x = (point.x - KEYX)/KEYSIZE;
		y = (point.y - KEYY)/KEYSIZE;
		KeyDown = x + y * KEYCOL + 1;
		RECT r = { KEYX+KEYSIZE*x, KEYY+KEYSIZE*y, KEYX+KEYSIZE*(x+1), KEYY+KEYSIZE*(y+1) };
		InvalidateRect(hWnd,&r,TRUE);
	}
	else if (point.x>=GRIDX && point.x<=GRIDX+GRIDSIZE && point.y>=GRIDY && point.y<=GRIDY+GRIDSIZE ) {
		bLBDown = true;
		m_line[0] = point;
		m_nStrokeNo++;
		if (m_nStrokeNo>29)
			m_nStrokeNo = 0;
		m_strokes[m_nStrokeNo].StartStroke(point);
	}
	return 0;
}

LRESULT CALLBACK DoMouseMoveSip (HWND hWnd, UINT wMsg, WPARAM nFlags, LPARAM lParam)
{
	POINT point;
	point.x = LOWORD(lParam);
	point.y = HIWORD(lParam);

	// Check that the LButton is down
	if (nFlags&MK_LBUTTON==0)
		return 0;
	if (bLBDown==false && KeyDown==0) {
		DoLButtonDownSip(hWnd, wMsg, nFlags, lParam);	
	}
	else if (bLBDown) {
		m_line[1] = point;
		HDC hdc = GetDC(hWnd);
		Polyline(hdc, m_line, 2);
		ReleaseDC(hWnd, hdc);
		m_line[0] = m_line[1];
		m_strokes[m_nStrokeNo].AddToStroke(point);
	}
	return 0;
}

LRESULT CALLBACK DoLButtonUpSip (HWND hWnd, UINT wMsg, WPARAM nFlags, LPARAM lParam)
{
    ReleaseCapture();
	if (bLBDown) {
		bLBDown = false;
		timeleft = 7;
	}
	if (KeyDown) {
		SendChar(hWnd, BestChar[KeyDown-1], 1);
		int y = (KeyDown-1) / KEYCOL;
		int x = (KeyDown-1) - y*KEYCOL;
		RECT r = { KEYX+KEYSIZE*x, KEYY+KEYSIZE*y, KEYX+KEYSIZE*(x+1), KEYY+KEYSIZE*(y+1) };
		InvalidateRect(hWnd,&r,TRUE);
		KeyDown = 0;
	}
	return 0;
}

//----------------------------------------------------------------------
// DoDestroySip - Process WM_DESTROY message for window.
//
LRESULT CALLBACK DoDestroySip (HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	if (FontData!=NULL)
		UnmapViewOfFile(FontData);		

    LPSIPWNDSTRUCT pWndData;

    pWndData = (LPSIPWNDSTRUCT)GetWindowLong (hWnd, GWL_USERDATA);
    LocalFree (pWndData);
    return 0;
}
//----------------------------------------------------------------------
// DrawButton - Draws a button
//
void DrawButton(HDC hdc, int x, int y, TCHAR chr, BOOL fPressed)
{
	x = KEYX+KEYSIZE*x;
	y = KEYY+KEYSIZE*y;
	RECT rect = { x, y, x+KEYSIZE, y+KEYSIZE };
	HBRUSH newbrush;
	if (fPressed) {
		SelectObject(hdc, GetStockObject(WHITE_PEN));
		newbrush = CreateSolidBrush(RGB(0,0,0)); // Black
		//SelectObject(hdc, GetStockObject(BLACK_BRUSH));
		SetTextColor(hdc, RGB(255,255,255)); // White
		SetBkColor(hdc, RGB(0,0,0)); // Black
	}
	else {
		SelectObject(hdc, GetStockObject(BLACK_PEN));
		newbrush = CreateSolidBrush(RGB(255,255,255));
		//if (chr >= 0x4000) // kanji
		//	SetTextColor(hdc, RGB(0,0,255)); // Blue
		//else // ASCII, hiragana or katakana
			SetTextColor(hdc, RGB(0,0,0)); // Black
		if (chr < 0x0100) { // Ascii
			newbrush = CreateSolidBrush(RGB(128,255,128));
			SetBkColor(hdc, RGB(128,255,128)); // Green
		}
		else if (chr < 0x30A0) { // Hiragana
			newbrush = CreateSolidBrush(RGB(255,255,0));
			SetBkColor(hdc, RGB(255,255,0)); // Yellow
		}
		else if (chr < 0x4000) { // Katakana
			newbrush = CreateSolidBrush(RGB(0,255,255));
			SetBkColor(hdc, RGB(0,255,255)); // Cyan
		}
		else {
			newbrush = CreateSolidBrush(RGB(255,255,255));
			SetBkColor(hdc, RGB(255,255,255)); // White
		}
	}
	HBRUSH oldbrush = (HBRUSH)SelectObject(hdc, newbrush);
	Rectangle(hdc, x-1,y-1,x+KEYSIZE+1,y+KEYSIZE+1);
#ifdef x86
	DrawText(hdc,&chr,-1,&rect,DT_CENTER|DT_VCENTER|DT_SINGLELINE);
#endif
#ifndef x86
	DisplayBitmap(hdc, x+4, y+4, chr);
#endif
	SelectObject(hdc,oldbrush);
	DeleteObject(newbrush);
    return;
}
//
//----------------------------------------------------------------------
//
LRESULT CALLBACK DoTimerSip(HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	if (timeleft>0) {
		timeleft--;
		if (timeleft==0) {
			Recognise(hWnd);
			m_nStrokeNo = -1;
			InvalidateRect(hWnd,NULL,TRUE);
			SendChar(hWnd, BestChar[0], 0);
		}
	}
	return 0;
}

