// Stroke.cpp: implementation of the CStroke class.
//
//////////////////////////////////////////////////////////////////////

#include <Windows.h>
#include "Stroke.h"
#include "kanjipen.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#pragma intrinsic( labs , abs )

#define GRIDSIZE 70

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStroke::CStroke()
{
	iLen = 0;
}

CStroke::~CStroke()
{

}

void CStroke::StartStroke(POINT point)
{
	iLen = 0;
	// ignore 1st point as its often junk
	// m_point[iLen]= point;
	// iLen++;
}

void CStroke::AddToStroke(POINT point)
{
	// First point
	if (iLen==0) {
		m_point[iLen] = point;
		iLen++;
	}

	// Store only if moved significantly
	if (labs(m_point[iLen-1].x-point.x) < (GRIDSIZE/16) 
		&& labs(m_point[iLen-1].y-point.y) < (GRIDSIZE/16))
		return;

	// Store only if moved
	m_point[iLen] = point;
	iLen++;
	if (iLen>=MaxStrokeLen-1)
		iLen=0;

	if (iLen>=3) {
		// Thinning
		int xdif1 = m_point[iLen-2].x - m_point[iLen-3].x;
		int ydif1 = m_point[iLen-2].y - m_point[iLen-3].y;

		int xdif2 = m_point[iLen-1].x - m_point[iLen-2].x;
		int ydif2 = m_point[iLen-1].y - m_point[iLen-2].y;

		int iAng1 = Angle32(xdif1, ydif1);
		int iAng2 = Angle32(xdif2, ydif2);

		// delete mid point on a straight line
		if (iAng1==iAng2 || iAng2==32) { // straight line
			// delete mid point
			m_point[iLen-2] = m_point[iLen-1];
			iLen--;
		}
		else if (iLen>=4) {
			// delete 2 mid points if 1st segment is parallel to last 
			// and mid segment is almost the same direction 
			int xdif0 = m_point[iLen-3].x - m_point[iLen-4].x;
			int ydif0 = m_point[iLen-3].y - m_point[iLen-4].y;
			int iAng0 = Angle32(xdif0, ydif0);

			int iAngDif1 = iAng1 - iAng0;
			int iAngDif2 = iAng2 - iAng1;
			int iAbsAngDif1 = abs(iAngDif1);
			int iAbsAngDif2 = abs(iAngDif2);

			if (iAbsAngDif1 <= 2 && iAbsAngDif2 <= 2 && ((iAngDif1 < 0) != (iAngDif2 < 0))) {
				// delete 2 points
				m_point[iLen-3] = m_point[iLen-1];
				iLen-=2;
			}
			else {
				int xdifT = m_point[iLen-1].x - m_point[iLen-3].x;
				int ydifT = m_point[iLen-1].y - m_point[iLen-3].y;
				int iAngT = Angle32(xdifT, ydifT);
				int iAngDifT = iAngT - iAng0;
				int iAbsAngDifT = abs(iAngDifT);
				
				// Here we turn gentle bends into rougher stuff.
				if (iAbsAngDifT <= 3) {
					// delete 2 points
					m_point[iLen-3] = m_point[iLen-1];
					iLen-=2;
				}
			}
		}
	}
}


